      DOUBLE PRECISION FUNCTION 
     &                 MAP_STEEL_NEWF2 (TK,GM0,PSI,THETA,ND,CD,XB,U)
C
      IMPLICIT NONE
      DOUBLE PRECISION TK,GM0,PSI,THETA,ND,CD(4),XB,U
      DOUBLE PRECISION A,B,BETA,C,C1,C2,E,F,FGB,FGC,FHB,FHC,FST,G,GA
      DOUBLE PRECISION GAMMA,GB,GC,GNT,GSM,H,HA,HB,LGA,LHA,TC,R,RR
      DOUBLE PRECISION SND,UT,UT2,UW,MAP_STEEL_NEWF2,MAP_UTIL_FUNCT
      PARAMETER (R=8.314D0,RR=2540D0)
C
      C1 = CD(1)
C
C*******************************************************
C SET NEW U HERE
C
C   Linear change in UW sub-unit width from Chang's data (in micro meters)
C
      TC  = TK-273
      UW  = TC*0.001077D0 - 0.2681D0
C
C to ensure a lower limit to plate size
C
      IF (UW .LT. 0.05) UW=0.05
c
C  Converting from micro meters into mm.
C  UT is sub-unit thickness assumed to be 10 microns.
C
      UT  = 1.0D-2
      UT2 = UT**2
      U   = UW*1.0D-3
      U   = U*UT2
C
C*********************************************************
C
      C1   = C1/U
      BETA = CD(2)*(1.0D0 - CD(4)*XB)
C
c To prevent negative beta values:
C
      IF (BETA .LT. 0.0) BETA = 0.0001D0
      C2  = CD(3)
      GSM = ND
      GNT = 3.636*(TK-273.15) -2540D0
C
      A = 1.0D0/(THETA*GSM*C1)
      B = THETA*BETA
      GAMMA = C2*(GM0-GNT)/(RR*R*TK)
      C = C2/(R*TK)+C2*GM0/(RR*R*TK)
      E = GAMMA/B
      F = A*(B+1.0D0)
      FST = DEXP(C)/F
      GA  = 1.0D0+(B*PSI)
      IF (GA .LT. 0.0D0) GA=-GA
C
      LGA = DLOG(GA)
      GB  = (GAMMA*PSI)+E
      GB  = -GB
      FGB = MAP_UTIL_FUNCT(GB)
      GC  = -E
      FGC = MAP_UTIL_FUNCT(GC)
      G   = LGA+FGB-FGC
      HA  = 1.0D0-PSI
      LHA = DLOG(HA)
      HB  = HA*GAMMA
      FHB = MAP_UTIL_FUNCT(HB)
      FHC = MAP_UTIL_FUNCT(GAMMA)
      H   = LHA+FHB-FHC
      SND = G*DEXP(E)-H*DEXP(-GAMMA)
C
      MAP_STEEL_NEWF2 = FST*SND
C
      END
